# concordance pin-cushion plot, Gaj Vidmar, 2005 #
Page(200.0,200.0);
pi :=  3.14159265359;

# get data #
  s := false;
  while not(s) do
    begin
      e := [["File", "file", ["","*.dat"]],
           ["Judges (m)", "edit", "", 4],
           ["Objects (k)", "edit", "", 4]];
      s := MultiPromptDialog(e, r, :title "Concordance pin-cushion plot")
           and (length(r[2])>0) and (length(r[3])>0);
    end;
  if not(access(r[1],"r")) then
    begin
      error("Could not open file!");
      exit(1);
    end;
  m := atoi(r[2]);
  k := atoi(r[3]);
  n := m*(m-1)*k/2;
  data := new array(m);
  for i := 1 to m do
    data[i] := new array(k);
  f := fopen(r[1],"r");
  for i := 1 to m do
    for j := 1 to k do
      begin
        s := fgeti(f, data[i][j]);
        if not(s) then
          begin
            error("Error while reading file!");
            fclose(f);
            exit(1);
          end;
      end;
  fclose(f);

# rank differences #
  dif := new array(k);
  for i := 1 to k do
    dif[i] := 0;
  for i := 1 to m-1 do
    for j := i+1 to m do
      for h := 1 to k do
       begin
        x := abs(data[i][h] - data[j][h]); 
        dif[x+1] := dif[x+1] + 1;
       end;

# transformation matrix, the constant part #
  trmat := new array(9);
  trmat [3] := 25.0;
  trmat [6] := 25.0;
  trmat [7] := 0.0;
  trmat [8] := 0.0;
  trmat [9] := 1.0;

# drawing #
  for i := 1 to k do 
    if (dif[i]>0) then
     begin
      j := i - 1;
      trmat[1] := cos(-j*pi/(2*k-1));
      trmat[4] := sin(-j*pi/(2*k-1));
      trmat[5] := trmat[1];
      trmat[2] := -trmat[4];
      Transform(trmat);
        Line(0.0, 0.0, 0.0, 150.0*dif[i]/n);
      EndTransform();
     end;
  Rectangle(25.0-150/n, 25.0, 25.0+150/n, 25.0-150/n, :fillcolor "White");

EndPage();
